; BulderJones
; 1KB minigame
; by Stefano Tognon
; (C) 2002 Ice Team
; version 1.00

; Well, I like this competition even this year!!!
; This is my 5 game for C64

; Game concept:
;
; The game is a mix of BulderDash and Lazy Jones, so play it as needed...
;


      processor 6502
      org 4096-64
      
; Lazy Jones sprite
  .byte 0, 0, 0, 48, 0, 0, 112, 0, 0
  .byte 108, 0, 60, 104, 0, 214, 104, 1, 6
  .byte 108, 0, 204, 112, 0, 72, 48, 0, 120
  .byte 0, 0, 132, 255, 193, 50,137,35,50
  .byte 192, 21, 50, 165, 75, 50, 144, 5, 254
  .byte 79, 248, 204, 40, 8, 216, 31, 248, 252
  .byte 0, 1, 134, 0, 1, 131, 0, 7, 143, 0


SIZEY    = 18            ; size of y screen area
SIZEX    = 27            ; size of x screen area
LMEM     = 1024+(SIZEY-2)*40 ; low pointer of screen memory
EXIT_POS = 1065

; chars pointers
MASS   = 81            ; a mass
MASSC  = 113           ; the chr$ of the mass
EMPTY  = 32            ; empty space
DIAM   = 90            ; a diamond
DIAMC  = 122           ; the chr$ of the diamon 
BD     = 94            ; bulder dash
EN1    = 0             ; enemy 1
EXIT   = 86            ; exit
WALL   = 102           ; the wall
WALLC  = 166           ; the chr$ wall char
FULL   = 224           ; the earth

MAXDIAM  = 5           ; amx diamonds to pick up
MAXDELAY = 5           ; frame delay

POS    = $A5           ; A5-A6 position in bulder dash screen
POSTMP = $8D           ; 8D-8E temp position in the screen
POSBD  = $B2           ; B2-B3 bulder dash position
TMP    = $A9           ; tmp location
N_DIAM = $B0           ; number of diamons we have
DELAY  = $BE           ; delay for each frame
GO     = $BF           ; 1 = go with the game
DIR    = $BA           ; 0 = dx, 1=sx
OFF    = $BB           ; offeset of movement


PUT_CHAR   = $E716    ; put a char in the screen
SCREEN     = $E544    ; clean the screen
SET_COOR   = $E50C    ; set x/y coord
STRING     = $AB1E    ; put a string

RANDOM     = 54272+27 ; random number from osc 3


 org 4096

      lda  #15
      sta  54272+24       ; init volume

      lda  #0             ; black
      sta  53280
      sta  53281

      sta  GO             ; don't go with the game

      ; init random number generator
      lda  #129
      sta  54272+18
      sta  54272+14
      sta  54273+14

      ; init sprite pointer
      lda  #63
      sta  2040

      ; init sprite coord
      lda  #90
      sta  53248
      lda  #220
      sta  53249

      ; show sprite
      lda  #1
      sta  53248+21

      ;sta  53248+23
      ;sta  53248+29

      ; color white
      sta  53248+39


      ; init (called only one time)
      sei
      lda  #<irqR
      sta  $0314
      lda  #>irqR
      sta  $0315
      cli

; repear the game
repeatGame:

      lda  #5;               ; default color is white
      jsr  PUT_CHAR
      jsr  SCREEN

      ; create the bulderdash screen
create_screen:
      ldy  #SIZEX

      ; insert all the earth in the screen
loop1:
      lda  #WALL
      sta  1024,y
      sta  1664+40,y
      lda  #5           ; green color
      sta  55296,y
      sta  55936+40,y

      lda  #FULL
      sta  1064,y
      sta  1104,y
      sta  1144,y
      sta  1184,y
      sta  1224,y
      sta  1264,y
      sta  1304,y
      sta  1344,y
      sta  1384,y
      sta  1424,y
      sta  1464,y
      sta  1504,y
      sta  1544,y
      sta  1584,y
      sta  1624,y
      sta  1664,y
      dey
      bpl  loop1

      lda  #30          ; green
      jsr  PUT_CHAR
                        ; write sx vertical bar of screen
      ldx  #0
      ldy  #0

      sty  N_DIAM       ; reset here for saving a instruction

      lda  #SIZEY
      sta  TMP
      lda  #WALLC
      jsr  write_up
                        ; write dx vertical bar of screen
      ldx  #0
      ldy  #SIZEY
      sty  TMP
      ldy  #SIZEX
      jsr  write_up

                        ; write a vertical bar of wall
      ldx  #1

      stx  DELAY        ; init delay with 1 frame

      ldy  #SIZEY-3
      sty  TMP
      ldy  #5
      jsr  write_up


      ; write title string
      ldx  #03
      ldy  #29
      jsr  SET_COOR
      lda  #<Sbul
      ldy  #>Sbul
      jsr  STRING

      ; write exit string
      ldx  #20
      ldy  #33
      jsr  SET_COOR
      lda  #<Sexit
      ldy  #>Sexit
      jsr  STRING

      ; write the port
      lda  #FULL
      sta  1857+40
      sta  1858+40
      sta  1859+40
      sta  1860+40
      sta  1897+40
      sta  1900+40
      sta  1937+40
      sta  1940+40
      sta  1977+40
      sta  1980+40


      ; set bulderdash initial position
      lda  #<1065
      sta  POSBD
      lda  #>1065
      sta  POSBD+1

      lda  #BD
      sta  1065

      ; write empty space for enemy
      lda  #EMPTY
      sta  1626
      sta  1627
      sta  1628


      ; write enemy and set his position
      lda  #EN1
      sta  1625

      lda  #0
      sta  DIR                     ; direction dx
      sta  OFF                     ; from pos 0


      ; put some random masses
      lda  #40
      sta  TMP

loopMass:
      jsr  made_random

      lda  #MASSC
      jsr  PUT_CHAR

      dec  TMP
      bne  loopMass

      ; put some random diamon
      lda  #10
      sta  TMP

loopDiam:
      jsr  made_random

      lda  #DIAMC
      jsr  PUT_CHAR

      dec  TMP
      bne  loopDiam

      inc  GO         ; start the game

fire1:                ; fire always exit from game
      lda  #$10
      bit  $DC01
      bne  fire1

      lda  #0
      sta  GO
      jmp  repeatGame

made_random:
      lda  RANDOM
      and  #$07
      adc  #4
      tax

      lda  RANDOM
      and  #$0f
      adc  #8
      tay
      jsr  SET_COOR
      rts


Sbul:   .byte 5,"BULDERJONES",0
Sexit:  .byte "EXIT",0


; write a up line of the same contents
; reg x/y the y,x position, TMP the number of char to put, reg a the char to put
; the color must be already selected
write_up:
      pha
      jsr  SET_COOR
      pla
      jsr  PUT_CHAR
      inx
      dec  TMP
      bne  write_up
      rts

irqR:
      lda  GO
      beq  exitIrq

      dec  DELAY
      bne  exitIrq

      lda  #MAXDELAY
      sta  DELAY

      jsr  enemy_mov       ; move the enemy
      jsr  user_mov        ; move by user action
      ;jsr  user_mov       ; repeat two times, because I want that a mass
      ;                    ; did not kill the bd too much soon
      jsr  scan

exitIrq:
      jmp  $EA7D          ; exit with ack interrupt


; execute the calculation of the bulder dash phisic.
; it starts from dx and low of screen, go sx and then one row up
scan:
      lda  #<LMEM
      sta  POS
      lda  #>LMEM
      sta  POS+1

      ldx  #SIZEY
col:
      ldy  #SIZEX
row:

      jsr  decision        ; calculate the decision

      dey
      bne  row
                            ; sub 40 chars for previous row
      lda  POS
      sec
      sbc  #40
      sta  POS
      bcs  skip1
      dec  POS+1
skip1:
      dex
      bne  col
      rts





decision:

      ; init the tmp pointer 40 locations ahead
      lda  POS+1
      sta  POSTMP+1
      lda  POS
      ;sta  POSTMP
      clc
      adc  #40
      sta  POSTMP
      bcc  skip2
      inc  POSTMP+1
skip2:

      lda  (POS),y

      cmp  #MASS
      beq  after

      cmp  #DIAM
      bne  end_decision

after:                                  ; look if the peaces must fall down

      lda  (POSTMP),y                   ; read at the position below the actual

      cmp  #EMPTY
      beq  fall_down

      cmp  #MASS
      beq  after2

      cmp  #DIAM
      bne  end_decision

      ; test at dx if all empty
after2:
      iny
      lda  (POS),y
      cmp  #EMPTY
      bne  test_sx

      lda  (POSTMP),y
      cmp  #EMPTY
      beq  at_dx

      ;test at sx if all empty
test_sx:
      dey
      dey
      lda  (POS),y
      cmp  #EMPTY
      bne  exit_sx

      lda  (POSTMP),y
      cmp  #EMPTY
      beq  at_sx

exit_sx:
      iny
end_decision:
      rts

      ; made the mass or diamon to fall down
fall_down:
      lda  (POS),y
      sta  (POSTMP),y

      lda  #EMPTY
      sta  (POS),y

                              ; made fall down sound
      lda  #$80               ; release gate
      sta  54272+4

      lda  #$81               ; noise
      sta  54272+4
      lda  #01
      sta  54272+5

      lda  #117
      sta  54272
      sta  54272+1

      ; check if there is a collision with b.d. or enemy
check_collision:
      tya
      sty  TMP
      clc
      adc  #40
      tay
      lda  (POSTMP),y

      cmp  #BD                   ; is the bulderdash?
      beq  died

      ;cmp  #EN1                  ; is the enemy 1 ?
      ;beq  kill

      ldy  TMP
      rts

      ; self mofified code for look at sx or dx
at_sx:
      iny ;*
      lda  #$88                  ; dey opcode
      sta  inst_dey_iny          ; self modifed code
      bne  common

at_dx:
      dey ;*
      lda  #$C8                  ; iny opcode
      sta  inst_dey_iny          ; self modified code

common:
      lda  (POS),y
      sty  TMP
      pha

      lda  #EMPTY                ; put empty where there was the object
      sta  (POS),y

      pla

inst_dey_iny:
      .byte 00

      sta  (POSTMP),y            ; put in new position
      ;tya
      jmp  check_collision       ; check for died of kill

;kill:


user_mov:
      lda  POSBD
      sta  POSTMP
      lda  POSBD+1
      sta  POSTMP+1

      ; user movement

      ; look for direction
      lda  $DC01
      eor  #$FF
      sta  TMP

      lda  #$01                   ; test for up
      bit  TMP
      bne  is_up
notUp:
      asl                         ; test for dn
      bit  TMP
      bne  is_dn
notDn:
      asl
      bit  TMP
      bne  is_sx
notSx:
      asl
      bit  TMP
      bne  is_dx

      rts

died:
      ; write exit string
      lda  #4
      sta  1497
      sta  1500
      lda  #9
      sta  1498
      lda  #5
      sta  1499
      dec  GO
      rts


is_up:
      lda  POSTMP
      sec
      sbc  #40
      sta  POSTMP
      bcs  skip3
      dec  POSTMP+1
skip3:
      jsr  make_mov
      rts

is_dn:
      lda  POSTMP
      clc
      adc  #40
      sta  POSTMP
      bcc  skip4
      inc  POSTMP+1
skip4:
      jsr  make_mov
      rts

is_sx:
      dec  POSTMP
      lda  POSTMP
      cmp  #$ff
      bne  skip5
      dec  POSTMP+1
skip5:
      jsr  make_mov
      rts

is_dx:
      inc  POSTMP
      bne  skip6
      inc  POSTMP+1
skip6:
      jsr  make_mov
      rts


     ; make the movement of DB
make_mov:

     ldy  #0
     lda  (POSTMP),y                 ; byte of where to go

     cmp  #EMPTY
     beq  goto_postmp

     cmp  #FULL
     beq  goto_postmp

     cmp  #DIAM
     beq  pick_diamond

     cmp  #EXIT
     beq  win

     cmp  #EN1
     beq  died

     rts

win:
      ; write exit string
      lda  #23
      sta  1497
      lda  #9
      sta  1498
      lda  #14
      sta  1499
      dec  GO
      rts



     ; copy tmp location to bulder dash location
copy_loc:
     lda  POSTMP
     sta  POSBD
     lda  POSTMP+1
     sta  POSBD+1
     rts

goto_postmp

                              ; made step sound
      lda  #$80               ; release gate
      sta  54272+11

      lda  #$11               ; triangle
      sta  54272+11
      lda  #01
      sta  54272+12

      lda  #100
      sta  54272+7
      sta  54272+8


     lda  #BD
     sta  (POSTMP),y
     lda  #EMPTY
     sta  (POSBD),y

     jsr  copy_loc

     rts

pick_diamond:
     inc  N_DIAM
     lda  N_DIAM
     cmp  #MAXDIAM
     bne  goto_postmp

     lda  #EXIT                     ; put exit onto exit position
     sta  EXIT_POS
     bne  goto_postmp


enemy_mov:
     lda  #EMPTY                    ; put empty where there is the enemy
     ldy  OFF
     sta  1625,y

     lda  DIR
     beq  go_dx

go_sx:
     ldy  OFF
     beq  change_dx

     dey
     sty  OFF
     jmp  moving

change_dx:
     inc  DIR
     bne  moving

go_dx:
     lda  OFF
     cmp  #3
     beq  change_sx
     tay
     iny
     sty  OFF

moving:
     lda  1625,y                     ; test if the BD died
     cmp  #BD
     bne  skipD
     jmp  died

skipD:

     lda  #EN1
     sta  1625,y
     rts

change_sx:
      dec  DIR
      jmp  moving


;continue_dx:
;     lda  (POSTMP),y
;     cmp  #MASS
;     bne  exitdx

;     iny
;     lda  (POSTMP),y
;     cmp  #EMPTY
;     bne  exitdx

;     lda  #MASS
;     sta  (POSTMP),y
;     dey
;     lda  #BD
;     sta  (POSTMP),y
;     lda  #EMPTY
;     sta  (POSBD),y
;     jsr  copy_loc
;exitdx:
     ;....


;continue_sx:
;     lda  POSTMP+1
;     sta  POS+1
;     lda  POSTMP
;     sta  POS

;     dec  POS
;     bcs  skip7
;     dec  POS+1
;skip7:

;     lda  (POSTMP),y
;     cmp  #MASS
;     bne  exitsx
;     lda  (POS),y
;     cmp  #EMPTY
;     bne  exitsx

;     lda  #MASS
;     sta  (POS),y
;     lda  #BD
;     sta  (POSTMP),y
;     lda  #EMPTY
;     sta  (POSBD),y
;     jsr  copy_loc
;exitsx:
     ;...




